<!doctype html>
<html class="not-ready lg:text-base" lang="en">
  <head>
  <meta charset="utf-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no" />

  <!-- Title -->
  <title>
    mini-project2 - Home
  </title>

  <!-- Meta -->
  <meta name="theme-color" />

  <!-- Author -->
  
  <meta name="description" content="mini-project2" />
  <meta name="author" content="mini-project2" />
  

  <!-- CSS & JS -->
  <link rel="preload stylesheet" as="style" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/main.css" />
  <style>
    :root {
      --bg: #f4f4f5;
      --bg-dark: #18181b;
      --header: #e4e4e7;
      --header-dark: #27272a;
    }
  </style>

  

  <!-- Dark Icon -->
  <link rel="preload" as="image" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/icons/theme.svg" />

  <!-- Math -->
  
  <!---->

  <!-- Mermaid -->
  
  <!---->

  <!-- Favicon -->
  <link rel="icon" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/favicon.ico" />
  <link rel="apple-touch-icon" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/apple-touch-icon.png" />

  <!-- Feeds -->
  
  <!---->
  
  <link
    rel="alternate"
    type="application/atom+xml"
    title="Atom"
    href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/atom.xml"
  />
  
  <!---->
  

  <!-- Canonical -->
  <link rel="canonical" href="https:&#x2F;&#x2F;individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io&#x2F;projects&#x2F;project2&#x2F;" />
</head>

  <body class="text-black duration-200 ease-out dark:text-white">
    <header
  class="header fixed top-0 z-40 mx-auto min-h-[3.5rem] w-full"
>
  <div class="mx-auto w-full max-w-4xl p-3 lg:flex lg:justify-between">
    <div class="flex justify-between">
      <div class="flex items-center">
        <a class="text-2xl font-semibold" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io">Home</a>
        <div
          class="btn-dark ml-4 h-6 w-6 shrink-0 cursor-pointer text-[0] [background:url(./icons/theme.svg)_left_center/cover_no-repeat] dark:invert dark:[background-position:right]"
          role="button"
          aria-label="Dark"
        ></div>
      </div>
      
      <div
        class="btn-menu relative z-50 flex h-8 w-8 shrink-0 cursor-pointer flex-col items-center justify-center gap-2.5 lg:hidden"
        role="button"
        aria-label="Menu"
      ></div>
      
    </div>
    <script>
      // base
      const htmlClass = document.documentElement.classList;
      setTimeout(() => {
        htmlClass.remove("not-ready");
      }, 10);

      // mobile menu
      const btnMenu = document.querySelector(".btn-menu");
      btnMenu?.addEventListener("click", () => {
        htmlClass.toggle("open");
      });

      // dark theme
      const setDark = (isDark) => {
        htmlClass[isDark ? "add" : "remove"]("dark");
        localStorage.setItem("dark", isDark);
      };

      // init
      const darkScheme = window.matchMedia("(prefers-color-scheme: dark)");
      if (htmlClass.contains("dark")) {
        setDark(true);
      } else {
        const darkVal = localStorage.getItem("dark");
        setDark(darkVal ? darkVal === "true" : darkScheme.matches);
      }

      // listen system
      darkScheme.addEventListener("change", (event) => {
        setDark(event.matches);
      });

      // manual switch
      const btnDark = document.querySelector(".btn-dark");
      btnDark.addEventListener("click", () => {
        setDark(localStorage.getItem("dark") !== "true");
      });
    </script>
    
    <nav class="flex w-full items-center lg:w-auto">
      <ul
        class="nav-wrapper flex w-full flex-col py-2 lg:w-auto lg:flex-row lg:self-center lg:py-0"
      >
        
        <li>
          <a
            class="primary-link block py-2 text-center text-lg font-medium lg:px-3 lg:py-0"
            href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects"
            >Projects</a
          >
        </li>
        
        <li>
          <a
            class="primary-link block py-2 text-center text-lg font-medium lg:px-3 lg:py-0"
            href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/About"
            >About</a
          >
        </li>
        
      </ul>
    </nav>
    
  </div>
</header>


    <main
      class="prose prose-neutral relative mx-auto min-h-[calc(100%-9rem)] max-w-3xl px-4 pb-16 pt-32 dark:prose-invert"
    >
      
<article>
  <header class="mb-16">
    <h1 class="!my-0 pb-2.5">mini-project2</h1>
    <div class="text-sm antialiased opacity-60">
  
  <time>2024-02-09</time>
  <span class="mx-1">&middot;</span>
  <span>2min</span>
  <!---->
  
  <!---->
  
  <span class="mx-1">&middot;</span>
  <span>yanbo</span>
  
</div>

  </header>

  

  <!-- TOC -->
  <!---->
<div class="block-bg mb-12 flex rounded-lg p-2 text-lg">
  <details>
    <summary class="cursor-pointer py-1 pl-4">
      <span>Table of Contents</span>
    </summary>
    <div class="px-2">
      <ul>
        
        <li>
          <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project2/#yg229-mini-project-2"
            >yg229_mini_project_2</a
          >
          
          <ul>
            
            <li>
              <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project2/#author"
                >Author</a
              >
            </li>
            
            <li>
              <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project2/#api-gateway"
                >API Gateway</a
              >
            </li>
            
            <li>
              <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project2/#configuration-and-initialization"
                >Configuration and Initialization:</a
              >
            </li>
            
            <li>
              <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project2/#s3-interaction"
                >S3 Interaction:</a
              >
            </li>
            
            <li>
              <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project2/#csv-processing"
                >CSV Processing:</a
              >
            </li>
            
            <li>
              <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project2/#response-construction"
                >Response Construction:</a
              >
            </li>
            
            <li>
              <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project2/#input-csv"
                >Input CSV:</a
              >
            </li>
            
            <li>
              <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project2/#run-on-local"
                >Run on local:</a
              >
            </li>
            
            <li>
              <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project2/#delpoy-on-aws"
                >Delpoy on AWS:</a
              >
            </li>
            
            <li>
              <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project2/#api-gateway-integration-result"
                >API Gateway Integration result</a
              >
            </li>
            
            <li>
              <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project2/#run-on-aws"
                >Run on AWS:</a
              >
            </li>
            
          </ul>
          
        </li>
        
      </ul>
    </div>
  </details>
</div>

<!---->

  <!-- Content -->
  <section><ul>
<li>Link to mini-project 2: <a href="https://gitlab.com/YanboGuan/ids721-week-2-project.git">GitLab repo</a></li>
</ul>
<h1 id="yg229-mini-project-2">yg229_mini_project_2</h1>
<p>This AWS Lambda function that interacts with Amazon S3 to perform sum operation of a list on a CSV file. </p>
<h2 id="author">Author</h2>
<p>Yanbo Guan</p>
<h2 id="api-gateway">API Gateway</h2>
<p><a href="https://wqg87aw2pe.execute-api.us-east-1.amazonaws.com/default/new-lambda-project">Link</a></p>
<h2 id="configuration-and-initialization">Configuration and Initialization:</h2>
<p>It initializes the AWS SDK for Rust with a region provider, defaulting to &quot;us-east-1&quot; if no region is specified in the environment.
Sets up a logging subscriber using tracing_subscriber to filter logs at the INFO level.</p>
<h2 id="s3-interaction">S3 Interaction:</h2>
<p>The function creates an S3 client using the AWS SDK configuration loaded from the environment.
It then retrieves an object from an S3 bucket named &quot;mini2yb&quot; with a key &quot;mini2data.csv&quot;, which is expected to be a CSV file.</p>
<h2 id="csv-processing">CSV Processing:</h2>
<p>The content of the CSV file is read as a string and processed using the csv crate to deserialize it into records based on the CsvRecord struct, which expects each record to contain a list field as a string.</p>
<h2 id="response-construction">Response Construction:</h2>
<p>After processing all records, the function constructs an ApiResponse struct containing the vector of original list strings and the total sum of all numbers found in the CSV file.
This response struct is then serialized into a JSON string and included in the body of an HTTP response with a 200 OK status and application/json content type.</p>
<h2 id="input-csv">Input CSV:</h2>
<pre style="background-color:#2b303b;color:#c0c5ce;"><code><span>list
</span><span>&quot;[1,3,5,7,9,11,13]&quot;
</span><span>
</span></code></pre>
<h2 id="run-on-local">Run on local:</h2>
<p><code>cargo lambda watch</code></p>
<p><img src="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project2/local.png" alt="Local result" title="Demo on local" /></p>
<h2 id="delpoy-on-aws">Delpoy on AWS:</h2>
<ol>
<li><code>cargo lambda build --release</code></li>
<li><code>cargo lambda deploy</code></li>
</ol>
<h2 id="api-gateway-integration-result">API Gateway Integration result</h2>
<p><img src="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project2/addapi.png" alt="API Gateway Integration" title="Add API Gateway" /></p>
<h2 id="run-on-aws">Run on AWS:</h2>
<p><img src="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project2/api.png" alt="AWS Result" title="Dem on AWS" /></p>
</section>

  <hr />

  <!-- Post Taxonomies -->
  
<!---->

  <!-- Post Nav -->
  
<nav class="block-bg mt-12 flex rounded-lg text-lg">
  
  <a
    class="block-hover-mask flex w-1/2 items-center rounded-l-md p-6 pr-3 font-semibold no-underline"
    href="https:&#x2F;&#x2F;individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io&#x2F;projects&#x2F;project1&#x2F;"
    ><span class="mr-1.5">←</span><span>mini-project1</span></a
  >
  <!---->
  
  <a
    class="block-hover-mask ml-auto flex w-1/2 items-center justify-end rounded-r-md p-6 pl-3 font-semibold no-underline"
    href="https:&#x2F;&#x2F;individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io&#x2F;projects&#x2F;project3&#x2F;"
    ><span>mini-project3</span><span class="ml-1.5">→</span></a
  >
  
</nav>

<!---->

  <!-- Comment -->
  
</article>

    </main>

    <footer class="mx-auto flex max-w-3xl flex-wrap items-center px-8 py-4 text-sm opacity-60">
  <div class="mr-auto basis-full lg:basis-1/2">
    &copy; 2020 -  2024
    <a class="link" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io"
      >yanbo</a
    >
     |<!---->
    <!---->
    <a class="link" href="https:&#x2F;&#x2F;creativecommons.org&#x2F;licenses&#x2F;by-sa&#x2F;4.0&#x2F;deed" rel="noopener" target="_blank">
      CC BY-SA 4.0
    </a>
    <!---->
    
  </div>
  <div class="flex basis-full lg:basis-1/2 lg:justify-end">
    <a class="link mr-6 lg:ml-6" href="https://www.getzola.org/" rel="noopener" target="_blank"
      >Powered by Zola</a
    >
    <a class="link" href="https://github.com/st1020/kita" rel="noopener" target="_blank">✎ Kita</a>
  </div>
</footer>

  </body>
</html>
